<template>
    <div class="orders">
        <v-row
            :class="[
                { 'pl-5 pr-5': $vuetify.breakpoint.smAndDown },
                { 'pl-16 pr-16': $vuetify.breakpoint.mdAndUp },
            ]"
        >
            <v-col v-if="$vuetify.breakpoint.mdAndUp" cols="3">
                <menu-bar />
            </v-col>
            <v-col>
                <v-row
                    :class="[
                        { 'pt-16 pl-0 pr-0': $vuetify.breakpoint.smAndDown },
                        { 'pl-16 pr-16': $vuetify.breakpoint.mdAndUp },
                    ]"
                >
                    <v-col>
                        <h1 class="font-syne-bold">
                            {{ $t('dashboard.menu.ORDERS') }}
                        </h1>
                    </v-col>
                </v-row>

                <v-row
                    :class="[
                        { 'pl-0 pr-0': $vuetify.breakpoint.smAndDown },
                        { 'pl-16 pr-16 pb-16': $vuetify.breakpoint.mdAndUp },
                    ]"
                >
                    <v-col cols="12">
                        <!-- ORDERS TABLE -->
                        <v-row>
                            <v-col cols="12">
                                <v-data-table
                                    :headers="headers"
                                    :items="orders"
                                    item-key="id"
                                    :options.sync="options"
                                    :loading="dataLoading"
                                    class="
                                        elevation-1
                                        transparent-bg
                                        font-metropolis-regular
                                    "
                                >
                                    <template v-slot:item.status="{ item }">
                                        <v-chip
                                            :color="getColor(item.status)"
                                            dark
                                        >
                                            {{ $t('orders.' + item.status) }}
                                        </v-chip>
                                    </template>
                                    <template v-slot:item.actions="{ item }">
                                        <v-btn
                                            x-small
                                            icon
                                            @click="goToPage(item.id)"
                                        >
                                            <v-icon> mdi-eye </v-icon>
                                        </v-btn>
                                    </template>
                                </v-data-table>
                            </v-col>
                        </v-row>
                    </v-col>
                </v-row>
            </v-col>
        </v-row>
    </div>
</template>

<script lang="ts">
import { Vue, Component, Watch } from 'vue-property-decorator'
import { mapGetters } from 'vuex'
import moment from 'moment'
import MenuBar from '~/components/dashboard/menuBar.vue'

Vue.component('menu-bar', MenuBar)

@Component<any>({
    middleware: ['authenticate'],
    head() {
        return {
            titleTemplate: '%s | ' + this.$t('dashboard.menu.HOME'),
            title: this.$t('dashboard.menu.ORDERS'),
        }
    },
    computed: mapGetters({
        menus: 'menu/getMenuDashboard',
    }),
})
export default class Orders extends Vue {
    // Data
    menus!: any
    selectedPage: Number = 3 // orders
    dataLoading: boolean = false
    options = {
        page: 1,
        itemsPerPage: 5,
    }

    headers: any = [
        {
            text: this.$t('orders.orderId'),
            align: 'start',
            sortable: false,
            value: 'id',
        },
        { text: this.$t('orders.date'), value: 'date', sortable: false },
        { text: this.$t('orders.amount'), value: 'total', sortable: false },
        {
            text: this.$t('orders.shipmentStatus'),
            value: 'status',
            sortable: false,
        },
        {
            text: this.$t('orders.businessType'),
            value: 'type',
            sortable: false,
        },
        { text: 'Actions', value: 'actions', sortable: false },
    ]

    orders: any = []

    // Watch
    @Watch('options')
    datatableHandler() {
        this.getOrders()
    }

    // Methods
    goToPage(id: Number) {
        this.$router.push(this.menus.ORDERS.path + '/' + id)
    }

    getColor(status) {
        let $defaultColor = 'red'
        switch (status) {
            case 'DELIVERED':
                $defaultColor = 'green'
                break
            case 'PENDING':
                $defaultColor = 'orange'
                break
        }

        return $defaultColor
    }

    getOrders() {
        this.dataLoading = true
        const { page, itemsPerPage } = this.options

        this.$api.user.orders(itemsPerPage, page).then(({ data }) => {
            // Assign Item
            for (const item of data.data) {
                let productItems = ''
                for (const pi of item.items) {
                    productItems += pi.variant.name + ''
                }
                this.orders.push({
                    id: item.id,
                    date: moment(item.order_at).format('DD/MM/YYYY HH:mm'),
                    items: productItems,
                    shippingAddress: item.shipping_address,
                    status: item.status.name.toUpperCase(),
                    total:
                        item.currency.toUpperCase() +
                        ' ' +
                        item.amount.toString(),
                    type: item.business_type.name,
                })
            }

            this.dataLoading = false
        })
    }

    created() {
        this.$store.dispatch('menu/selectDashboardMenu', this.selectedPage)
    }
}
</script>
